/* Andrei Parvu
   O(N^2)
*/

#include <cstdio>
#include <cstring>
#include <cassert>
#include <set>
#include <vector>

using namespace std;

const int NMAX = 3000, MAXK = 1000000;
const long long INF = 2000000000000000LL, MAXINPUT = 2200000000LL;

long long d[NMAX + 2][NMAX + 2];

#ifdef DEBUG
  int prev[NMAX + 2][NMAX + 2];
#endif

long long b[NMAX + 2], bprim[NMAX + 2], a[NMAX + 2];
set<long long> elems;

long long abs(long long x) {
  return x < 0 ? -x : x;
}

int main() {
  freopen("ktown.in", "rt", stdin);
  freopen("ktown.out", "wt", stdout);

  int n, k;

  assert(scanf("%d%d", &n, &k) == 2);
  assert(1 <= n && n <= NMAX);
  assert(1 <= n && n <= MAXK);

  for (int i = 1; i <= n; i++) {
    assert(scanf("%lld", &a[i]) == 1);
    assert(-MAXINPUT <= a[i] && a[i] <= MAXINPUT);

    b[i] = a[i] - (long long)(i - 1) * k;

    elems.insert(b[i]);
  }

  set<long long>::iterator it;

  int nr = 0;
  for (it = elems.begin(); it != elems.end(); it++) {
    bprim[++nr] = *it;
  }

  for (int i = 0; i <= NMAX; i++) {
    for (int j = 0; j <= NMAX; j++) {
      d[i][j] = INF;
    }
  }

  for (int i = 1; i <= nr; i++) {
    d[1][i] = abs(b[1] - bprim[i]);
  }

  long long rez = INF;

  #ifdef DEBUG
    int pp = 0;
  #endif

  for (int i = 2; i <= n; i++) {
    long long valMin = INF;
    #ifdef DEBUG
      int poz = 0;
    #endif

    for (int j = 1; j <= nr; j++) {
      if (d[i - 1][j] < valMin) {
        valMin = d[i - 1][j];
        #ifdef DEBUG
          poz = j;
        #endif
      }

      if (d[i][j] > valMin + abs(b[i] - bprim[j])) {
        d[i][j] = valMin + abs(b[i] - bprim[j]);

        #ifdef DEBUG
          prev[i][j] = poz;
        #endif
      }

      if (i == n) {
        if (rez > d[i][j]) {
          rez = d[i][j];
          #ifdef DEBUG
            pp = j;
          #endif
        }
      }
    }
  }

  printf("%lld\n", rez);

  #ifdef DEBUG
    vector<long long> rsp;

    for (int i = n; i; i--) {
      rsp.push_back(bprim[pp] /*+ (long long)(i - 1) * k*/);
      pp = prev[i][pp];
    }

    long long realCost = 0;
    for (int i = n - 1; i >= 0; i--) {
      fprintf(stderr, "%lld ", rsp[i]);

      realCost += abs(rsp[i] - a[n - i]);

      if (i > 0) {
        if (rsp[i - 1] - rsp[i] < k) {
          //fprintf(stderr, "FUCK!\n");
        }
      }
    }
    fprintf(stderr, "\n%lld\n", realCost);
  #endif

  return 0;
}

