/* Andrei Ciocan
   O(Flux) :)
*/

#include <stdio.h>
#include <vector>
#include <string.h>
#include <iostream>


using namespace std;

#define maxn 3300
const long long inf = 1000000000000000LL;
#define ll long long
#define maxx 1000010

int N, M, S, D,k;
int Drum, L;
vector <ll> A[maxn];
ll v[maxn];
int G[maxn]; ll Dist[maxn] ; int From[maxn];
int Q[maxx], U[maxn];
ll C[maxn][maxn], F[maxn][maxn], Cost[maxn][maxn];

int nod1, nod2 ;

inline int getCost(int i, int j ) {
  nod1 = Q[i];
  nod2 = A[nod1][j];

  if (nod1==0 || nod2==N)
    return 0;

  if (F[nod1][nod2]>=0)
    return 1;

  if (F[nod1][nod2]<0)
    return -1;
}

long long BellmanFord()
{
  int i, j,nod;

  for (i = 1; i <= N+1; i++)
  {
    Dist[i] = inf;
    From[i] = -1;
  }

  Dist[S] = 0;
  L = 1;
  Q[L] = S;
  memset(U, 0, sizeof(U));
  U[S] = 1;

  for (i = 1; i <= L; i++)
  {
    nod = Q[i];
    for (j=0; j<G[nod]; j++) {
      if (C[nod][A[nod][j]]-F[nod][A[nod][j]]>0 && Dist[nod]+getCost(i,j)<Dist[A[nod][j]])
      {
        Dist[A[nod][j]] = Dist[nod] + getCost(i,j);
        From[A[nod][j]] = nod;
        if (!U[A[nod][j]])
        {
          Q[++L] = A[nod][j];
          U[Q[L]] = 1;
        }
      }
    }
    U[nod] = 0;
  }

  if (Dist[D] != inf)
  {
    ll Vmin = inf;
    Drum = 1;

    for (i = D; i != S; i = From[i]) {
      if (F[From[i]][i]>=0) {
        Vmin = min(Vmin, C[From[i]][i] - F[From[i]][i]);
      } else {
        Vmin = min ( Vmin , - F[From[i]][i]);
      }
    }

    for (i = D; i != S; i = From[i])
    {
      F[From[i]][i] += Vmin;
      F[i][From[i]] -= Vmin;
    }

    return (long long)Vmin * Dist[D];
  }
  return 0;
}

ll Flux()
{
  ll Rez = 0;
  Drum = 1;


  while (Drum)
  {
    Drum = 0;
    Rez+=  BellmanFord();
  }

  return Rez;
}

void citire() {
  freopen("ktown.in", "r", stdin);
  int i, j ;
  scanf("%d %d", &N, &k);

  for (i=1;i<=N;i++)
    scanf("%lld", &v[i]);

  S=0; D = N ;

  for (i = 1; i < N-1; i++)
  {
    A[i].push_back(i+1);
    A[i+1].push_back(i);

    C[i][i+1] = inf;
    C[i+1][i] = inf;
    Cost[i][i+1] = 1;
    Cost[i+1][i] = 1;
  }

  for (i=1;i<N;i++) {
    if (v[i+1]-v[i] >k) {
      A[0].push_back(i);
      C[0][i]=v[i+1]-v[i]-k;
    }

    if (v[i+1]-v[i] < k) {
      A[i].push_back(N);
      C[i][N]=k-v[i+1]+v[i];
    }
  }

  A[0].push_back(N+1);
  C[0][N+1]=inf;

  A[N+1].push_back(1);
  C[N+1][1]=inf;
  Cost[N+1][1]=1;

  A[N+1].push_back(N-1);
  C[N+1][N-1]=inf;
  Cost[N+1][N-1]=1;
}

int main()
{
  freopen("ktown.out", "w", stdout);

  citire();

  for (ll i = 0; i <= N+1; i++) G[i] = A[i].size();

  printf("%lld\n", Flux());

  return 0;
}
