//Mugurel Ionut Andreica - 100 p
#include <stdio.h>
#include <algorithm>
#include <vector>

using namespace std;

#define OFFSET 5011
#define NMAX 10011
#define MMAX 1011
#define INF 1000000001
#define DEBUG 0

vector<pair<int, int> > v;
int N, M;
int K;

void ReadInput() {
	int i;
	freopen("mafioti.in", "r", stdin);
	scanf("%d %d %d", &N, &M, &K);
	v.resize(2 * N + 1);
	for (i = 0; i < N; i++) {
		scanf("%d", &(v[2 * i].first));
		v[2 * i].second = 1;
		v[2 * i + 1].first = v[2 * i].first + K - 1;
		v[2 * i + 1].second = 0;
	}

	v[2 * N].first = -K;
	v[2 * N].second = 0;
}

int psum[NMAX];
int lmin[2][NMAX][MMAX], vmin[OFFSET + 10][MMAX * 2];
int livmin[OFFSET + 10], lsvmin[OFFSET + 10];
int pvmin[OFFSET + 10][MMAX * 2];

void Solve() {
	int i, j, k, jmin;
	int extra;

	sort(v.begin(), v.end());

	//for (i = 1; i < v.size(); i++)
	//	fprintf(stderr, "  coord=%lld: dif=%lld\n", v[i].first, v[i].first - v[i - 1].first);

	psum[0] = 0;
	for (i = 1; i < v.size(); i++)
		psum[i] = psum[i - 1] + v[i].second;

	// Initialize.
	for (j = 1; j <= M; j++)
		lmin[0][0][j] = lmin[1][0][j] = INF;

	lmin[0][0][0] = lmin[1][0][0] = 0;

	vmin[0 + OFFSET][0] = -v[0].first;
	livmin[0 + OFFSET] = lsvmin[0 + OFFSET] = pvmin[0 + OFFSET][0] = 0;

	for (j = -N; j <= 0; j++)
		if (j != 0) {
			livmin[j + OFFSET] = 0;
			lsvmin[j + OFFSET] = -1;
		}

	// DP.
	for (i = 1; i < v.size(); i++) {
		// Init lmin[*][i][*].
		for (j = 0; j <= M; j++) {
			lmin[0][i][j] = INF;
			lmin[1][i][j] = lmin[1][i - 1][j];
		}

		// Find the largest index k such that v[i].first - v[k].first >= K.
		for (k = i; k >= 0; k--)
			if (v[i].first - v[k].first >= K)
				break;

		// Compute jmin.
		if (k < 0)
			jmin = psum[i];
		else
			jmin = psum[i] - psum[k];

		if (jmin > M)
			jmin = M;

		if (DEBUG)
			fprintf(stderr, "i=%d: coord=%lld point=%d psum=%d => k=%d jmin=%d\n", i, v[i].first, v[i].second, psum[i], k, jmin);

		// Compute lmin[0][i][*].
		for (j = jmin; j <= M && j <= psum[i]; j++) {
			// Update the deque first.
			while (livmin[j - psum[i] + OFFSET] <= lsvmin[j - psum[i] + OFFSET] && pvmin[j - psum[i] + OFFSET][livmin[j - psum[i] + OFFSET]] <= k)
				livmin[j - psum[i] + OFFSET]++;

			if (livmin[j - psum[i] + OFFSET] <= lsvmin[j - psum[i] + OFFSET] &&
				vmin[j - psum[i] + OFFSET][livmin[j - psum[i] + OFFSET]] + v[i].first < lmin[0][i][j]) {
					lmin[0][i][j] = vmin[j - psum[i] + OFFSET][livmin[j - psum[i] + OFFSET]] + v[i].first;
					if (DEBUG)
						fprintf(stderr, "  upd i=%d j=%d diag=%d: vmin=%lld => new lmin=%lld\n", i, j, j - psum[i], vmin[j - psum[i] + OFFSET][livmin[j - psum[i] + OFFSET]], lmin[0][i][j]);
				}

			if (k >= 0)
				extra = lmin[1][k][j - jmin];
			else if (j == jmin)
				extra = 0;
			else
				extra = INF;

			if (extra + K < lmin[0][i][j])
				lmin[0][i][j] = extra + K;
		}

		// Update lmin[1][i][*] and the deques.
		for (j = 0; j <= M && j <= psum[i]; j++) {
			if (lmin[0][i][j] < lmin[1][i][j])
				lmin[1][i][j] = lmin[0][i][j];

			extra = lmin[0][i][j] - v[i].first;
			while (livmin[j - psum[i] + OFFSET] <= lsvmin[j - psum[i] + OFFSET] &&
				   vmin[j - psum[i] + OFFSET][lsvmin[j - psum[i] + OFFSET]] > extra)
				lsvmin[j - psum[i] + OFFSET]--;

			lsvmin[j - psum[i] + OFFSET]++;
			vmin[j - psum[i] + OFFSET][lsvmin[j - psum[i] + OFFSET]] = extra;
			pvmin[j - psum[i] + OFFSET][lsvmin[j - psum[i] + OFFSET]] = i;
			if (DEBUG)
				fprintf(stderr, "  add to deque: i=%d j=%d diag=%d vmin=%lld\n", i, j, j - psum[i], extra);
		}

		if (DEBUG) {
			for (j = 0; j <= M; j++)
				fprintf(stderr, "  j=%d: %lld %lld\n", j, lmin[0][i][j], lmin[1][i][j]);
		}
	}
}

void WriteOutput() {
	freopen("mafioti.out", "w", stdout);
	printf("%d\n", lmin[1][v.size() - 1][M]);
	fprintf(stderr, "%d\n", lmin[1][v.size() - 1][M]);
}

int main() {
	ReadInput();
	Solve();
	WriteOutput();
	return 0;
}
