//Andrei Grigorean 100p
#include <cassert>

#include <algorithm>
#include <fstream>
using namespace std;

ifstream fin("permsort.in");
ofstream fout("permsort.out");

const int MAX_N = 1000000;

int n;
int v[MAX_N + 1];
int aib[MAX_N + 1];
int pos[MAX_N + 1];

void update(int pos, int val) {
    while (pos <= n) {
        aib[pos] += val;
        pos += pos & -pos;
    }
}

int query(int pos) {
    int sol = 0;
    while (pos) {
        sol += aib[pos];
        pos -= pos & -pos;
    }
    return sol;
}

void check_permutation(int v[], int n) {
    int u[MAX_N];
    for (int i = 1; i <= n; ++i)
        u[i] = v[i];
    sort(u + 1, u + n + 1);
    for (int i = 1; i <= n; ++i)
        assert(u[i] == i);
}

void read() {
    fin >> n;
    assert(1 <= n && n <= MAX_N);
    for (int i = 1; i <= n; ++i)
        fin >> v[i];
    check_permutation(v, n);
}

inline void make_move(int type, int pos) {
    fout << (type == 0 ? "P" : "S") << " " << pos << "\n";
}

void solve() {
    fout << 2 * n - 1 << "\n";

    // move n;
    int p = -1;
    for (int i = 1; i <= n; ++i)
        if (v[i] == n) {
            p = i;
            break;
        }
    make_move(0, p);
    reverse(v + 1, v + p + 1);

    // preprocess
    for (int i = n; i > 1; --i) {
        pos[v[i]] = n - query(v[i]);
        update(v[i], 1);
    }

    for (int i = n - 1; i >= 1; --i) {
        make_move(0, pos[i] - 1);
        make_move(0, pos[i]);
    }
}

int main() {
    read();
    solve();
}
