//Andrei Gigorean
#include <cassert>

#include <algorithm>
#include <fstream>
using namespace std;

ifstream fin("permsort.in");
ofstream fout("permsort.out");

const int MAX_N = 1000000;

int n;
int v[MAX_N + 1];
int place[MAX_N + 1];

void read() {
    fin >> n;
    for (int i = 1; i <= n; ++i)
        fin >> v[i];
}

void move(int type, int pos) {
    fout << (type == 0 ? 'P' : 'S') << " " << pos << "\n";
}

void reverse(int start, int finish) {
    for (int i = start, j = finish; i < j; ++i, --j) {
        swap(v[i], v[j]);
        swap(place[v[i]], place[v[j]]);
    }
}

void solve() {
    for (int i = 1; i <= n; ++i)
        place[v[i]] = i;

    // print no of moves
    fout << 2 * n - 1 << "\n";

    // move first element
    move(0, place[1]);
    reverse(1, place[1]);

    for (int i = 2; i <= n; ++i) {
        int pos = place[i];

        move(1, pos);
        reverse(pos, n);

        move(1, i);
        reverse(i, n);
    }
}

int main() {
    read();
    solve();
}
