#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <ctime>
 
#include <string>

using namespace std;
 
    class node
    {
        public:
        int priority,key,reverse,sons;
        node *left,*right;
        node(int _priority,int _key,node* _left,node* _right):priority(_priority),key(_key),reverse(0),sons((_left?_left->sons:0)+(_right?_right->sons:0)+1),left(_left),right(_right){}
    }*root;
    inline void _reverse(node* &r)
    {
        if(r==0)
            return;
        if(r->left)
            r->left->reverse^=r->reverse;
        if(r->right)
            r->right->reverse^=r->reverse;
        if(r->reverse)
        {
            r->reverse=0;
            node *aux=r->left;
            r->left=r->right;
            r->right=aux;
        }
    }
    inline void _get_sons(node* &r)
    {
        r->sons=((r->left?r->left->sons:0)+(r->right?r->right->sons:0)+1);
    }
    inline void _rot_left(node* &r)
    {
        node* aux=r->left;
        r->left=aux->right;
        aux->right=r;
        _get_sons(r);_get_sons(aux);
        r=aux;
    }
    inline void _rot_right(node* &r)
    {
        node* aux=r->right;
        r->right=aux->left;
        aux->left=r;
        _get_sons(r);_get_sons(aux);
        r=aux;
    }
    inline void _balance(node* &r)
    {
        if(r->left&&r->left->priority<r->priority)
            _rot_left(r);
        else
            if(r->right&&r->right->priority<r->priority)
                _rot_right(r);
            else
                _get_sons(r);
    }
    void _insert(node* &r,int k,int priority,int key)
    {
        if(r==0)
        {
            r=new node(priority,key,0,0);
            return;
        }
        _reverse(r);_reverse(r->left);_reverse(r->right);
        if(k<=(r->left?r->left->sons:0))
            _insert(r->left,k,priority,key);
        else
            _insert(r->right,k-1-(r->left?r->left->sons:0),priority,key);
        _balance(r);
    }
    void _erase(node* &r)
    {
        if(r->left==0&&r->right==0)
        {
            delete r,r=0;
            return;
        }
        _reverse(r);_reverse(r->left);_reverse(r->right);
        if(r->left&&r->right)
            if(r->left->priority<r->right->priority)
                _rot_left(r),_erase(r->right);
            else
                _rot_right(r),_erase(r->left);
        else
            if(r->left)
                _rot_left(r),_erase(r->right);
            else
                _rot_right(r),_erase(r->left);
        _balance(r);
    }
    node* _find(node *r,int k)
    {
        _reverse(r);
        if((r->left?r->left->sons:0)+1==k)
            return r;
        if((r->left?r->left->sons:0)>=k)
            return _find(r->left,k);
        else
            return _find(r->right,k-(r->left?r->left->sons:0)-1);
    }
    inline void insert(int k,int x)
    {
        _insert(root,k-1,rand()+1,x);
    }
    inline int find(int k)
    {
        return (_find(root,k))->key;
    }
    inline void reverse(int x,int y)
    {
        node *left,*right,*center;
        _insert(root,x-1,0,0);
        left=root->left;
        _insert(root->right,y-x+1,0,0);
        right=root->right->right;
        center=root->right->left;
        center->reverse^=1;
        _reverse(center);
        delete root->right;
        delete root;
        root=new node(0,0,left,center);
        _erase(root);
        center=root;root=new node(0,0,center,right);
        _erase(root);
    }
    void treap()
    {
        root=0;
        srand(time(NULL));
    }

const int MAX_N = 1000000;

int n, m;
int v[MAX_N + 1];

void printResult(string message, int points) {
    printf("%d %s\n", points, message.c_str());
    exit(0);
}

int main()
{
    FILE *fin = fopen("permsort.in", "r");
    if (!fin)
        printResult("EROARE! Nu am putut deschide fisierul de intrare", 0);

    if (fscanf(fin, "%d", &n) != 1)
        printResult("EROARE! Fisier de intrare corupt", 0);
    for (int i = 1; i <= n; ++i) {
        if (fscanf(fin, "%d", &v[i]) != 1)
            printResult("EROARE! Fisier de intrare corupt", 0);
    }

    // init treap
    treap();
    for(int i = 1; i <= n; ++i)
        insert(i, i);

    FILE *fout = fopen("permsort.out", "r");
    if (!fout)
        printResult("Fisier de iesire lipsa", 0);

    if (fscanf(fout, "%d", &m) != 1)
        printResult("Fisier de iesire corupt", 0);
    if (m > 5 * n)
        printResult("Prea multe mutari", 0);
    
    for (int i = 1; i <= m; ++i) {
        char op;
        int pos;

        if (fscanf(fout, " %c %d", &op, &pos) != 2)
            printResult("Fisier de iesire corupt", 0);
        if (op < 1 || op > n)
            printResult("Fisier de iesire corupt", 0);

        if (op == 'P') reverse(1, pos);
        else if (op == 'S') reverse(pos, n);
        else printResult("Fisier de iesire corupt", 0);
    }

    for (int i = 1; i <= n; ++i) {
        if (v[find(i)] != i)
            printResult("Wrong answer", 0);
    }

    if (m <= 2 * n)
        printResult("OK", 10);
    printResult("OK", 5);
}
